package body Pilas is
	procedure Apilar(P: in out Pila; E: in TElemento) is
	begin
		-- Apilar un elemento es aadirlo como primero de
		-- la lista de elementos
		Asignar(P.Elementos,Crear(E,P.Elementos));
		P.Tamao := P.Tamao + 1;
	exception
		when E_No_espacio => raise E_Pila_Llena;
	end Apilar;

	procedure Desapilar(P: in out Pila) is
	begin
		-- Desapilar un elemento es quedarse con el resto de
		-- la lista de elementos
		Asignar(P.Elementos,Resto(P.Elementos));
		P.Tamao := P.Tamao - 1;
	exception
		when E_Lista_Vaca => raise E_Pila_Vaca;
	end Desapilar;

	function Examinar(P: in Pila) return TElemento is
	begin
		-- El elemento de la cima de la pila es el primero de
		-- la lista de elementos
		return Primero(P.elementos);
	exception
		when E_Lista_Vaca => raise E_Pila_Vaca;
	end Examinar;

	function Es_Vaca(P: in Pila) return Boolean is
	begin
		-- La pila est vaca cuando no tiene elementos
		return P.Tamao = 0;
	end Es_Vaca;

	function Tamao(P: in Pila) return Natural is
	begin
		-- Se devuelve el tamao almacenado
		return P.Tamao;
	end Tamao;
end Pilas;
